CREATE OR REPLACE FUNCTION
ivo_hasword(haystack TEXT, needle TEXT) RETURNS INTEGER AS $func$
    SELECT CASE WHEN to_tsvector($1) @@ plainto_tsquery($2) 
        THEN 1 
        ELSE 0 
    END
$func$ LANGUAGE SQL;

CREATE OR REPLACE FUNCTION 
ivo_hashlist_has(hashlist TEXT, item TEXT) RETURNS INTEGER AS $func$
    -- postgres can't RE-escape a user string; hence, we'll have
    -- to work on the hashlist (this assumes hashlist is already
    -- lowercased).
    SELECT CASE WHEN lower($2) = ANY(string_to_array($1, '#'))
        THEN 1 
        ELSE 0 
    END
$func$ LANGUAGE SQL;

CREATE OR REPLACE FUNCTION 
ivo_nocasematch(value TEXT, pattern TEXT) RETURNS INTEGER AS $func$
    SELECT CASE WHEN $1 ILIKE $2
        THEN 1 
        ELSE 0 
    END
$func$ LANGUAGE SQL;

-- ivo_string_agg directly corresponds to string_agg; this translation
-- should be done in the ADQL translator.
